/**
 * Code to handle context menu's 
 * "Annotate selection" option.
 */

function annozillaAnnotateSelection() {
    if (! Components.classes["@mozilla.org/xpointer-service;1"]) {
	window.alert("Please install the XPointerService from http://xpointerlib.mozdev.org/");
    }
    
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var seln = focusedWindow.__proto__.getSelection.call(focusedWindow);
    var url = stripURL(focusedWindow.location.href);
    
    var xptrService = Components.classes["@mozilla.org/xpointer-service;1"].getService().QueryInterface(Components.interfaces.nsIXPointerService);
    
    var xptr = xptrService.createXPointerFromSelection(seln, focusedWindow.document);
		
    window.openDialog("chrome://annozilla/content/edit_body.xul",
		      "annotation-body" + Math.random(),
		      "chrome,resizable,dialog=no",
		      null,
		      url,
		      xptr,
		      null);
}

/**
 * Private function to strip query
 * strings off of URLs. (we don't want
 * to be nosy!)
 *
 * @param url String URL to strip query strings from
 * @return URL string stripped of queries
 */
function stripURL(url) {
  if (!url || ('string' != typeof(url)) ||  ('' == url) || url == 'about:blank') {
    return "about:blank";
  }
  
  // Strip off any query strings (Don't want to be too nosy).
  var queryPart = url.indexOf('?');
  if (queryPart != -1) {
    url = url.slice(0, queryPart);
  }
  
  return url;    
}
