/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Annozilla.
 *
 * The Initial Developer of the Original Code is
 * Matthew Wilson <matthew@mjwilson.demon.co.uk>.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var server;
var annotation;
var editorShell;
var replacement;

function onload () {

    if (window.arguments) {
        server   = window.arguments[0];
        annotation = window.arguments[1];
        replacement = window.arguments[2];
        if (annotation.data.type) {
            document.getElementById("annotationType").value =
                annotation.data.type;
        }
        if (annotation.data.language) {
            document.getElementById("annotationLanguage").value =
                annotation.data.type;
        } else if (window.arguments[3]) {
            document.getElementById("annotationLanguage").value =
                window.arguments[3];
        }
    }
    editorOnLoad(annotation.body ? annotation.body : 'about:blank');
}


function editorOnLoad(url)
{
    // load url somehow
}

function post () {

    // Need to coerce the edited document into well-formed XML
    // (so editorShell.GetContentsAs('text/html', 0) won't do)
    var doc = editorShell.editorDocument;
    var s = new XMLSerializer();
    var xml = s.serializeToString(doc);
    xml = xml.replace (/<!DOCTYPE[^>]*>/,'');
    xml = xml.replace (/ _moz_[a-z]*="[^"]*"/g,'');
    xml = xml.replace (/type="_moz"/g,'');

    if (replacement) {

        server.replace_annotation (
                annotation.resource,
                document.getElementById ("annotationType").value,
                annotation.data.annotates,
                annotation.data.context,
                annotation.data.creator,
                document.getElementById ("annotationLanguage").value,
                annotation.data.created,
                formatDate(),
                annotation.data.title,
                xml,
                PostComplete,
                PostError
                );
    } else {
        var date = formatDate();
        server.post_annotation (
                document.getElementById ("annotationType").value,
                annotation.data.annotates,
                annotation.data.context,
                annotation.data.creator,
                document.getElementById ("annotationLanguage").value,
                date,
                date,
                "test title", //annotation.data.title,
                xml,
                PostComplete,
                PostError
                );
    }
}

function PostComplete () {
    window.alert ("Successfully posted annotation");
}

function PostError (error ) {
    window.alert ("Error posting annotation " + error);
}

